import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Entity;
import javax.ws.rs.core.MediaType;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.github.dockerjava.api.DockerClient;
import com.github.dockerjava.api.command.CreateServiceCmd;
import com.github.dockerjava.api.command.CreateServiceResponse;
import com.github.dockerjava.api.model.ContainerSpec;
import com.github.dockerjava.api.model.NetworkAttachmentConfig;
import com.github.dockerjava.api.model.ServiceSpec;
import com.github.dockerjava.api.model.TaskSpec;
import com.github.dockerjava.core.DefaultDockerClientConfig;
import com.github.dockerjava.core.DockerClientBuilder;

public class Temp {

	public static void main(String[] args) {
//		DockerClient dockerClient = DockerClientBuilder.getInstance(DefaultDockerClientConfig.createDefaultConfigBuilder().build())
//				.build();
		DockerClient dockerClient = DockerClientBuilder.getInstance(DefaultDockerClientConfig.createDefaultConfigBuilder().withDockerHost("tcp://127.0.0.1:4444").withDockerTlsVerify(false).build())
				.build();
		
		String imageName = "imageName";
		ServiceSpec serviceSpecification = new ServiceSpec();
		ContainerSpec containerSpecification = new ContainerSpec().withImage(imageName);
		// generate unique container name
		String containerName = "containerName";
		serviceSpecification.withName(containerName);
		// create env vars to pass
			containerSpecification.withEnv(new String[] { "CONTAINER_NAME_KEY=" + containerName ,  "SOME_OTHER_ENV=value" });
		// create container labels
		Map<String, String> labels = new HashMap<>();
		labels.put("LABEL_TYPE", "containerType");
		labels.put("LABEL_PARENT", "parentId");
		containerSpecification.withLabels(labels);

		serviceSpecification
				.withNetworks(Arrays.asList(new NetworkAttachmentConfig().withTarget("HOBBIT_DOCKER_NETWORK")));

			containerSpecification.withCommand("command[0]");

		// trigger creation
		CreateServiceResponse resp = null;
		try {
			dockerClient.createServiceCmd(
					serviceSpecification.withTaskTemplate(new TaskSpec().withContainerSpec(containerSpecification))).exec();
			//Client client = ClientBuilder.newClient();
			//Entity<CreateServiceCmd> cmdEntity = Entity.entity(dockerClient.createServiceCmd(
			//		serviceSpecification.withTaskTemplate(new TaskSpec().withContainerSpec(containerSpecification))), MediaType.valueOf(MediaType.APPLICATION_JSON));
			//javax.ws.rs.client.WebTarget webResource = client.target("http://127.0.0.1:4444");
			//webResource.request().accept(MediaType.APPLICATION_JSON)
            //.post(cmdEntity);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
}
